/*
 * lab1.c
 */

#include "lcd.h"

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>


void exemplu_lcd()
{
    LCD_print("Hello World!");

    for(;;);
}

void task1_lcd()
{
    /* TODO task 1 LCD */

    // configurare porturi folosite
    DDRB &= ~((1 << PB0) | (1 << PB1));
    PORTB |= (1 << PB0) | (1 << PB1);

    // initializari
    char str[] = "Hello World";
    LCD_print(str);

    // main loop
    int8_t pos = 0;
    uint8_t PINB_old = 0xff;
    for(;;)
    {
        uint8_t PINB_crt = PINB;

        if((PINB_old & (1 << PB1)) && !(PINB_crt & (1 << PB1)))
        {
            pos += 1;
            if(pos + (sizeof(str) - 1) > 16)
                pos = 16 - (sizeof(str) - 1);

            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_printAt(pos, str);
        }
        
        if((PINB_old & (1 << PB0)) && !(PINB_crt & (1 << PB0)))
        {
            pos -= 1;
            if(pos < 0)
                pos = 0;

            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_printAt(pos, str);
        }

        PINB_old = PINB_crt;

        _delay_ms(5);
	}
}


void bonus_lcd()
{
    /* TODO bonus LCD */

    // configurare porturi folosite
    DDRB &= ~((1 << PB0) | (1 << PB1));
    PORTB |= (1 << PB0) | (1 << PB1);

    // creare caracter custom
    uint8_t chuck[] = {0x00, 0x0e, 0x0e, 0x04, 0x0e, 0x04, 0x0e, 0xa};
    LCD_writeInstr(LCD_INSTR_CGRAM);
    for(uint8_t i = 0; i < sizeof(chuck); ++i)
        LCD_writeData(chuck[i]);
    LCD_writeInstr(LCD_INSTR_DDRAM);

    // main loop
    int8_t pos_old = 0x40;
    uint8_t PINB_old = 0xff;
    LCD_putCharAt(pos_old, 0);
    for(;;)
    {
        uint8_t PINB_crt = PINB;

        uint8_t pb0 = (PINB_old & (1 << PB0)) && !(PINB_crt & (1 << PB0));
        uint8_t pb1 = (PINB_old & (1 << PB1)) && !(PINB_crt & (1 << PB1));

        int8_t pos = pos_old;

        if(!(PINB_crt & (1 << PB0)) && !(PINB_crt & (1 << PB1)))
        {
            if(pos >= 0x40)
                pos -= 0x40;
        }
        else if(pb0)
        {
            pos -= 1;
            if(pos == 0x3f)
                pos = 0x40;
        }
        else if(pb1)
        {
            pos += 1;
            if(pos == 0x50)
                pos = 0x4f;
        }
        else
        {
            if(pos <= 0x1f)
                pos += 0x40;
        }

        if(pos != pos_old)
        {
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_putCharAt(pos, 0);
            
            pos_old = pos;
        }

        PINB_old = PINB_crt;

        _delay_ms(5);
	}
}

int main()
{

    //LCD	
    LCD_init();

    exemplu_lcd();
//  task1_lcd();
//  task2_lcd();
//  bonus_lcd();

    return 0;
}

